//                       Funktionen aus Aufgabe 20

//    Riemann-Integration
double riemann( double (* const func)(double), const double &a, const double &b, 
		const int n)
{
  double s = 0.0,       //  Summe
         h = (b-a)/n;   //  Intervalllaenge
  
  for (int j=1; j<=n; ++j)
  {
    s += func(a+j*h)*h;
  }
 
  return s;
}


#include <iostream>         // cout, endl
#include <cmath>            //  fabs()
using namespace std;

//    Differenzieren
double derivative( double (* const func)(double), const double &x, const double &h)
{
  return ( func(x+h) - func(x-h) )/2/h;
}


//                       Funktionen aus Aufgabe 21


//    Riemann-Integration (hier klappt Overloading da 4. Parameter anders)
double riemann( double (* const func)(double), const double &a, const double &b, 
		const double eps)
{
 int    n = 5;        // Anzahl der Intervalle im Integrationsbereich [a,b]
 double r_old, r_new;
 
 //    Verdoppele die Anzahl der Intervalle, bis die geforderte Genauigkeit erreicht ist
 r_new = riemann(func, a, b, n);
 do
 {
   r_old = r_new;
   n = 2*n;
   r_new = riemann(func, a, b, n);
 }
 while ( fabs(r_new-r_old) > eps );
 
 cout << " Abbruch bei  n = " << n << endl; 

 return  r_new;
}


//    Differenzieren (andere Funktionsname, da alle Parameter gleich sind 
//                    und die Parameterliste nicht umgestellt wurde)
double derivative2( double (* const func)(double), const double &x, const double eps)
{
 double h = 0.1;       // Schrittweite fuer numerische Differentiation
 
 double r_old, r_new;
 
 //    Halbiere die Schrittweite h, bis die geforderte Genauigkeit erreicht ist
 r_new = derivative(func, x, h);
 do
 {
   r_old = r_new;
   h = h/2;
   r_new = derivative(func, x, h);
 }
 while ( fabs(r_new-r_old) > eps );
 
 cout << " Abbruch bei  h = " << h << endl; 

 return  r_new;
}
