//	SS07, 5. Uebung, Aufgabe24   (Horner)
//	g++ -O3 -Wall -pedantic bsp_24.cpp bsp_24_fkt.cpp

#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
using namespace std;
#include "bsp_24_fkt.hpp"

//--------------------------
void read_koeff(const string& name, polynom& kk)
{
 ifstream fin(name.c_str());

 if ( fin.is_open() )
 {
    fin >> kk.n;
//     cout << kk.n << endl;
    kk.a = new double [kk.n+1];   // Speicher allokieren!!  +1 !!
    for (int i=0; i<=kk.n; ++i)
    {
      fin >> kk.a[i];
//     cout << kk.a[i] << endl;
    }
 }
 else
 {
    cout << "\nFile " << name << "nicht gefunden.\n" ;
    kk.n = -1;
    kk.a = 0;
 }
 return;
}

//--------------------------
double polynom_pow(const double x, const polynom& kk)
{
  double sum = 0.0;
  for (int k=0; k<=kk.n; ++k)
  {
    sum += kk.a[k]*pow(x,k);   // + a_k*x^k
  }

  return sum;
}

//--------------------------
double polynom_mult(const double x, const polynom& kk)
{
  double sum = kk.a[0],
         xp  = 1.0;    // x^0

  for (int k=1; k<=kk.n; ++k)
  {
    xp  *= x;            // x^k
    sum += kk.a[k]*xp;   // + a_k*x^k
  }

  return sum;
}

//--------------------------
double horner(const double x, const polynom& kk)
{
  double sum = kk.a[kk.n];

  for (int k=kk.n-1; k>=0; --k)
  {
    sum = x*sum + kk.a[k];        // x*()+a_k
  }

  return sum;
}
