//      SS07, Aufg. 25: Volleyballturnier

//	g++ -Wall -pedantic bsp_25.cpp
#include <iostream>
#include <cmath>
#include <ctime>
using namespace std;

const int MAX_SETS=5;

struct match_team
{
  int nset;           // Anzahl gewonnener Saetze
  int pp[MAX_SETS];   // Anzahl der Punkte pro Satz
};

struct tab_entry
{
 int match_s, match_n;
 int set_s,set_n;
 int point_s, point_n;
};

///
void zero_entry(tab_entry &a)
{
  a.match_s = a.match_n = a.set_s = a.set_n = a.point_s = a.point_n = 0;
  return;
}

///
void zero_match(match_team &a)
{
  a.nset = 0;
  for (int i=0; i<MAX_SETS; ++i)  a.pp[i] = 0;
  return;
}

///
void add_spiel(tab_entry& ta, tab_entry& tb, const match_team& a, const match_team& b)
{
  if ( a.nset > b.nset )
  {
     ++ta.match_s;
     ++tb.match_n;
  }
  else
  {
     ++ta.match_n;
     ++tb.match_s;
  }
  ta.set_s += a.nset;  ta.set_n += b.nset;
  tb.set_s += b.nset;  tb.set_n += a.nset;

  for (int i=0; i<a.nset+b.nset; ++i)
  {
    ta.point_s += a.pp[i]; ta.point_n += b.pp[i];
    tb.point_s += b.pp[i]; tb.point_n += a.pp[i];
  }

  return;
}

bool smaller(const tab_entry& ta, const tab_entry& tb)
{
  bool bb;
//                            ungleiche #Gewinnspiele
  if ( ta.match_s != tb.match_s )
     bb = ta.match_s < tb.match_s;
//                            ungleiche Satzdifferenz
  else if ( (ta.set_s - ta.set_n) != (tb.set_s - tb.set_n) )
     bb = (ta.set_s - ta.set_n) < (tb.set_s - tb.set_n);
//                            ungleiche #Gewinnsaetze
  else if ( ta.set_s != tb.set_s )
     bb = ( ta.set_s < tb.set_s );
//                            ungleiche Punktdifferenz
  else if ( (ta.point_s - ta.point_n) != (tb.point_s - tb.point_n) )
    bb = (ta.point_s - ta.point_n) < (tb.point_s - tb.point_n);
//                            ungleiche #Gewinnpunkte
  else if ( ta.point_s != tb.point_s )
    bb = ( ta.point_s < tb.point_s );
//                            alles ist gleich
  else
    bb = false;

  return bb;
}


bool larger_equal(const tab_entry& ta, const tab_entry& tb)
{ return !smaller(ta, tb); }


void Ranking(const tab_entry t[], const int &n, int index[])
{
  for (int i=0; i<n; ++i)  index[i] = i;

// BubbleSort: Sortieren der Indexeintraege statt der Oroginaleintrge
  for (int i=0; i<n; ++i)
  {
    int &ii = index[i];
    for (int k=n-1; k>=i+1; --k)
    {
      int &kk = index[k];
      if ( smaller(t[ii], t[kk]) )
      {
      // swap(ii,kk);
        int tmp= ii;
	      ii = kk;
            kk = tmp;
      }

    }
  }

  return;
}


void Ausgabe(const tab_entry t[], const int &n, const int index[])
{
  cout << endl;
  for (int i=0; i<n; ++i)
   {
//      const tab_entry &ti = t[i];
     const tab_entry &ti = t[index[i]];
     cout << "Platz ";
     cout.width(2);
     cout << i+1 << ":  Team nr." << index[i] << "   ";
     cout.width(2);
     cout << ti.match_s << " ";
     cout.width(2);
     cout << ti.match_n << "   ";
     cout.width(2);
     cout << ti.set_s   << ":";
     cout.width(2);
     cout<< ti.set_n   << "   ";
     cout.width(3);
     cout << ti.point_s << ":";
     cout.width(3);
     cout << ti.point_n << endl;
    }
  cout << endl;
  return;
}

///
void Spielstand(const match_team& a, const match_team& b)
{
 cout << " " << a.nset << " : " << b.nset << "   ( ";
 for (int i=0; i<a.nset+b.nset; ++i )
 {
     cout << a.pp[i] << ":" << b.pp[i];
     if ( i+1 != a.nset+b.nset )  cout << " , ";
 }
 cout << " )" << endl;

 return;
}
///

//      Satzsimulation
//      count_a>count_b  ==> team A has won
void satz(int& count_a, int& count_b, const int& min_points,
          const double& rank_a=10.0, const double& rank_b=10.0)
{
 const double grenze = rank_a/(rank_a+rank_b);  // in [0,1]
 count_a = count_b = 0;                         // Punktezaehler

 while (max(count_a,count_b) < min_points || abs(count_a-count_b) <2 )
 {
//   cout << rand() << "  " << (rand()+0.0)/RAND_MAX << "  " << grenze << endl;
   if ( (rand()+0.0)/RAND_MAX <  grenze )
        ++count_a;
   else
        ++count_b;
 }
 return;
}


//  Spielsimulation
void spiel(match_team& a, match_team& b, const int& min_sets,
           const double& rank_a=10.0, const double& rank_b=10.0)
{
 int m_points = 25,
     nr_set   = 1;

 while (max(a.nset,b.nset) < min_sets)
 {

   if (nr_set==MAX_SETS)  m_points = 15;   // 5. Satz ist verk"uerzt
   satz(a.pp[nr_set-1], b.pp[nr_set-1], m_points);
   if ( a.pp[nr_set-1] > b.pp[nr_set-1] )
        ++a.nset;
   else
        ++b.nset;

   ++nr_set;
 }
 return;
}


//    Hauptprogramm:
int main(const int argc, const char* argv[])
{
 int n ;
 if (argc > 1)
     n = atoi(argv[1]);
 else
 {
     cout << "n = "; cin >> n;
 }

 tab_entry* team = new tab_entry [n];
 int*      index = new int [n];
                                // Alle Zaehler auf Null setzen
 for (int i=0; i<n; ++i)  zero_entry(team[i]);

 srand ( time(NULL) %(n*n) );

 for (int i=0; i<n; ++i)
 {
   for (int k=i+1; k<n; ++k)
   {
     match_team a,b;
     zero_match(a);            // Alle Zaehler auf Null setzen
     zero_match(b);

     spiel(a, b, 3);
     Spielstand(a, b);
     add_spiel(team[i], team[k], a, b);
   }
 }

 Ranking(team,n,index);
 Ausgabe(team,n,index);



 delete [] index;
 delete [] team;
 return 0;
}
