//		datum.cpp
#include <iostream>	   // ostream
#include <fstream>         // ifstream
#include <cassert>         // assert
#include "bsp_26_fkt.hpp"
using namespace std;

//--------------------------------------------------------------------
//		Default Constructor
Datum :: Datum()
{
 day_ = month_ = 1;
 year_ = 1800;
}

//--------------------------------------------------------------------
//		Parameter Constructor
Datum :: Datum(const unsigned short day, const unsigned short month,
   		const unsigned short year)
{
 day_   = day;
 month_ = month;
 year_  = year;
}

//--------------------------------------------------------------------
//		Copy Constructor
Datum :: Datum(const Datum &orig)
{
 day_   = orig.day_;
 month_ = orig.month_;
 year_  = orig.year_;
}

//--------------------------------------------------------------------
//		Constructor via file (�B)
Datum :: Datum(const char filename[])
{
 ifstream infile(filename);
 assert(infile.is_open());      // check whether file exists
 infile >> day_ >> month_ >> year_;
}

//--------------------------------------------------------------------
//		Destructor
Datum :: ~Datum()
{}				// nothing to do

//--------------------------------------------------------------------
//		Assignment operator
Datum& Datum :: operator = (const Datum &rhs)
{
 if ( &rhs != this )
 {
   day_   = rhs.day_;
   month_ = rhs.month_;
   year_  = rhs.year_;
 }

 return *this;
}

//--------------------------------------------------------------------
//		Comparison operator (earlier)
bool Datum :: operator < (const Datum &rhs) const
{
 bool bb;

 if ( year_ != rhs.year_ )
   {
     bb = ( year_ < rhs.year_ );
   }
 else if ( month_ != rhs.month_ )	// Gleiches Jahr ==> weiter mit Monat
   {
     bb = ( month_ < rhs.month_ );
   }
 else if ( day_ != rhs.day_ )		// Gleicher Monat ==> weiter mit Tag
   {
     bb = ( day_ < rhs.day_ );
   }
 else					// bleibt bloss noch gleicher Geburtstag uebrig
   {
     bb = false;
   }

 return bb;
}

//--------------------------------------------------------------------
//		Comparison operator (equal)
bool Datum :: operator == (const Datum &rhs) const
{
 return ( year_ == rhs.year_  && month_ == rhs.month_ && day_ == rhs.day_);
}

//--------------------------------------------------------------------
//		Print operator
ostream & operator<<(ostream  & s, const Datum & orig)
{
 s << orig.day_ << ". " << orig.month_ << ". " << orig.year_;

 return s;
}

















