#ifndef BSP_26_FKT
#define BSP_26_FKT

#include <iostream>
using namespace std;

/**
	Einfache Klasse zur Datumsspeicherung
	@param day_	Tag
	@param month_	Monat
	@param year_	Jahr  (short ist 2 Byte lang)

	@author		Gundolf Haase
	@version	2005/01/15
*/
class Datum
{
 private:		// Members
   unsigned short day_, month_, year_;

 public:		// Methods
/**	Standardkonstruktor: Der 1.1.1800 wird als Datum gesetzt.
*/
   Datum();

/**	Parameterkonstruktor: Das Datum wird entsprechend der Uebergabeparameter gesetzt.

	Parameter- und Standardkonstruktor koennen via optionaler
	Parameter in einer Methode kombiniert werden.
	@param	day	Tag
	@param	month	Monat
	@param	year	Jahr
*/
   Datum(const unsigned short day, const unsigned short month,
   		const unsigned short year);

//	Hint:	Default constructor and Parameter constructor
//		can be combined by using optional arguments
//  Datum(const unsigned short day = 1, const unsigned short month= 1,
//   		const unsigned short year= 1800);

/**	Copy-Konstruktor: Initialisiert die Instanz mit dem uebergebenen Datum.
	@param	orig	Inputdatum
*/
   Datum(const Datum &orig);

/**	Parameterkonstruktor: Datum aus File lesen.
	Das File wird geoeffnet und geschlossen.
	@param	filename	Name des Datenfiles
*/
   Datum(const char filename[]);

/**	Destruktor: Nichts zu tun (keine dynamischen Daten in Klasse).
*/
   ~Datum();

/**	Zuweisungsoperator: Kopieren des Datensatzes auf die Instanz.
	@param	rhs	Datum der rechten Seite
	@return		linke Seite (vom Zuweisungsoperator)
*/
   Datum& operator = (const Datum &rhs);

/**	Vergleichsoperator kleiner.
	@param	rhs	Datum rechts vom Operationszeichen
	@return		Ist linkes Datum frueher als rechtes Datum?
*/
   bool operator  < (const Datum &rhs) const;

/**	Vergleichsoperator gleich
	@param	rhs	Datum rechts vom Operationszeichen
	@return		Ist linkes Datum gleich dem rechten Datum?
*/
   bool operator == (const Datum &rhs) const;

/**	Ausgabeoperator (ist keine Methode der Klasse Datum!):
	Ausgabe des Datums, z.B.:

	cout << "Datum ist der " << datum << " anno domini." << endl;

	@param	s	vorhandener Ausgabestrom
	@param	orig	auszugebendes Datum
	@return		neuer Ausgabestrom mit angehaengtem Datum
*/
   friend ostream & operator<<(ostream  & s, const Datum & orig);
};

#endif
