//	SS07, 6. Uebung, Aufgabe27   (Klasse Polynom, Horner)
//	g++ -O2 -Wall -pedantic bsp_27.cpp bsp_27_fkt.cpp
//      icpc  -O2 -ipo -fp-model fast -mcpu=pentium4 -alias-args  bsp_27.cpp bsp_27_fkt.cpp

#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
using namespace std;
#include "bsp_27_fkt.hpp"

//--------------------------

void test_suite(const string& file, const double x)
{
 polynom pp(file);

//  cout << endl << pp << endl;
 double mx,px,hx;
 mx = pp.polynom_mult(x);
 px = pp.polynom_pow (x);
 hx = pp.horner      (x);
 cout << " mx = " << mx << "   px = " << px << "   hx = " << hx <<  endl;
}

//--------------------------

void test_timing(const string& file, const double x)
{
 polynom pp(file);

 double t, t1,t2,t3;
 const int NN = 1000;
//  cout << endl << pp << endl;

 double mx,px,hx;
 mx = pp.polynom_mult(x);
 px = pp.polynom_pow (x);
 hx = pp.horner      (x);

 t = clock();
 for (int j=0; j<NN; ++j)
    mx = pp.polynom_mult2(x);
 t1 = (clock()-t)/CLOCKS_PER_SEC;
 t = clock();
 for (int j=0; j<NN; ++j)
   px = pp.polynom_pow (x);
 t2 = (clock()-t)/CLOCKS_PER_SEC;
 t = clock();
 for (int j=0; j<NN; ++j)
    hx = pp.horner4     (x);
 t3 = (clock()-t)/CLOCKS_PER_SEC;

 cout << " mx = " << mx << "   px = " << px << "   hx = " << hx <<  endl;
 cout << " t1 = " << t1 << "   t2 = " << t2 << "   t3 = " << t3 <<  endl;
}

//--------------------------

int main()
{
 test_suite("data_24_a.txt", 3.78);
 test_suite("data_24_b.txt", -1.0087);
 test_suite("data_24_c.txt", -0.945);

 cout << "#######################################################" << endl;
 test_timing("data_24_a.txt", 3.78);
 test_timing("data_24_b.txt", -1.0087);
 test_timing("data_24_c.txt", -0.945);


//  system("pause");
 return 0;
}

//       ohne Optimierung (Datensatz c  in bsp_24_clock.cpp)
//   Mult           Power            Horner
// mx = 2.12677   px = 2.12677   hx = 2.12677         // Erg
// t1 = 84.22     t2 = 14.29     t3 = 1.18            // Sec

//       mit Optimierung -O3  (Datensatz c  in bsp_24_clock.cpp)
// mx = 2.12677   px = 2.12677   hx = 2.12677         // Erg
// t1 = 0.38      t2 = 11.82     t3 = 0.53            // Sec

//  polynom_mul2 :  t1 = 0.30
//  horner2      :  t3 = 0.31

