//  g++ -O2 -Wall -pedantic bsp_28.cpp bsp_28vec_fkt.cpp

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <cassert>
using namespace std;

#include "bsp_28vecErbe_fkt.hpp"

//   Implementation of the methods from class polynom

//
polynom::polynom()
 : vector<double>(0)               // member initialization
{
}
//
polynom::polynom(const string& file_name)
 : vector<double>(0)            // guarantee defined values
{
 ifstream fin(file_name.c_str());

 if( fin.is_open() )
 {
    int ngrad;
    fin >> ngrad;
//     cout << ngrad << endl;
    resize(ngrad+1);           // allocate ngrad+1 !!
    for (int i=0; i<=ngrad; ++i)
    {
      fin >> (*this)[i];
    }
 }
 else
 {
    cout << "\nFile " << file_name << "have not been found.\n" ;
    assert( fin.is_open() );         // exeption handling for the poor programmer
 }
 return;
}

ostream & operator<<(ostream  & s, const polynom & orig)
{
  s << " Polynom of degree " << orig.degree()
    << "has coefficient in decending order" << endl;
  cout.precision(3);
  for (int i=0; i<=orig.degree(); ++i)
    {
       s << orig[i] << "  ";
    }
  s << endl;

  return s;
}

//
double polynom::horner(const double x) const
{
  double sum = (*this)[degree()];

  for (int k=degree()-1; k>=0; --k)
  {
    sum = x*sum + (*this)[k];        // x*()+a_k
  }

  return sum;
}


//
double polynom::polynom_mult(const double x) const
{
  double sum = (*this)[0],
         xp  = 1.0;    // x^0

  for (int k=1; k<=degree(); ++k)
  {
    xp  *= x;               // x^k
    sum += (*this)[k]*xp;   // + a_k*x^k
  }

  return sum;
}


//
double polynom::polynom_pow(const double x) const
{
  double sum = 0.0;
  for (int k=0; k<=degree(); ++k)
  {
    sum += (*this)[k]*pow(x,k);   // + a_k*x^k
  }

  return sum;
}
