//	SS07, 4. Uebung, Aufgabe 12   (Funktion: string)
//          3 verschiedene Versionen der Implementierung

//	g++ -Wall -Weffc++ -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls -Wunreachable-code -Winline -pedantic bsp_12.cpp
//      valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_12 --show-reachable=yes ./a.out

#include <iostream>
#include <string>
using namespace std;

// Funktionsdefinitionen (=Funktionsdeklarationen   hier)

//  -------   einfache Realisierung (nicht ganz effizient)  -------
string reverseString1(const string& orig)
{
  const int lang=orig.size();
     string tmp(orig);

  for (int i=0; i<lang; ++i)
  {
     tmp[lang-i-1] = toupper(orig[i]);
  }

  return tmp;
}

//  -------   Realisierung in place (effizient, ueberschreibt Original)  -------
void reverseString2(string& orig)
{
  const int lang=orig.size();

  for (int i=0; i<(lang+1)/2; ++i)
  {
     const char tmp = orig[i];
     orig[i]        = toupper(orig[lang-i-1]);
     orig[lang-i-1] = toupper(tmp);
  }

  return;
}

//  -------   Realisierung in place fuer Char-Array (effizient, ueberschreibt Original)  -------
void reverseString3(char orig[], const int& lang)
{
  for (int i=0; i<(lang+1)/2; ++i)
  {
     const char tmp = orig[i];
     orig[i]        = toupper(orig[lang-i-1]);
     orig[lang-i-1] = toupper(tmp);
  }

  return;
}

//  -------   Realisierung in place (ueberschreibt Original, Nutzung der STL)
inline char gross(const char & cc) { return toupper(cc); }

void reverseString4(string& orig)
{
  reverse(orig.begin(), orig.end());  // Reihenfolge umkehren
  transform(orig.begin(), orig.end(), orig.begin(), gross); // klein--> Grossbuchstaben

  return;
}

// -------------    Hauptprogramm

int main()
{
 string given;
 cout << "String: "; cin >> given;

 //  Variante 1
 string erg1( reverseString1(given) );

  //  Variante 2
 string erg2(given);

 reverseString2(erg2);

   //  Variante 3
 char *erg3 = new char [given.size()+1];
 strcpy(erg3, &given[0]);
 //  bzw(STL): given.copy(erg3,given.size());

 reverseString3(erg3, given.size() );

 //  Variante 4
 string erg4(given);

 reverseString4(erg4);


 cout << endl;
 cout << " Var 1:   " << erg1 << endl;
 cout << " Var 2:   " << erg2 << endl;
 cout << " Var 3:   " << erg3 << endl;
 cout << " Var 4:   " << erg4 << endl;
cout << endl;

 delete [] erg3;

//  system("pause");
 return 0;
}
