//	SS07, 4. Uebung, Aufgabe 13   (Funktion: Roemische Ziffern)
//	g++ -Wall -Weffc++ -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls -Winline -pedantic bsp_13.cpp
//      valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_13 --show-reachable=yes ./a.out

#include <iostream>
#include <string>
// #include <locale>          // do_toupper
using namespace std;

// Funktionsdefinitionen (=Funktionsdeklarationen   hier)

//    ------  Grossbuchstaben (in place)  ----

void string_to_upper(string& a)
{
  for (unsigned int i=0; i<a.size(); ++i)
  {
    a[i] = toupper(a[i]);
  }
  return;
}

//    ------  Test auf gueltige Ziffern der roemischen Zahl
//            und Bestimmung der Positionswerte der Ziffern  ----

bool checkRoman(short int werte[], const string orig,
                const char rom[],  const short int val[], const int N)
{
  for (unsigned int i=0; i<orig.size(); ++i)
  {
      werte[i] = 0;        //  definierte Werte garantieren
  }

  bool bs=true;            //  ist orig eine roemische Zahl?
  unsigned int  is=0;
  while ( is < orig.size() && bs ) // Abbbruch falls keine roem. Zahl
  {
    const char &ss = orig[is];
    bool br  = false;      //  ist  ss  eine gueltige roemische Ziffer?
    int  ir  = 0;
    while ( ir < N && !br )        // Abbruch falls Ziffer gefunden wurde
    {
      br = br ||  ss == rom[ir];
      ++ir;
    }
    if (br && N>0)  werte[is] = val[ir-1];
    bs = bs && br;
    ++is;
  }
  return bs;
}

//    ------  Bestimmung  der Zahl aus den Positionswerten ----
//    geht davon aus, dass die roem. Zahl auch bzgl. der Positionen gueltig ist,

short int zahlenwert(const short int werte[], const int n)
{
  short int sum = 0;
  for (int i=0; i<n-1; ++i)
  {
    short int  si = werte[i];
    if ( si < werte[i+1] )
    {
      si = -si;
    }
    sum = sum + si;
  }
  sum += werte[n-1];

  return sum;
}


// Hauptprogramm

int main()
{
 const char       rom[] = {'I', 'V', 'X', 'L', 'C', 'D',  'M'};
 const short int  val[] = { 1,   5 , 10 , 50 , 100, 500, 1000};
 const int  N           = sizeof(rom)/sizeof(rom[0]);

 string given;
 cout << "roemische Zahl: "; cin >> given;
 cout << endl;

 string_to_upper(given);   // Grossbuchstaben garantieren
                           // Werte der Zahlenziffern speichern
 short int *werte = new short int [given.size()];

 bool bb = checkRoman(werte, given, rom, val, N);

 if ( bb )
 {
   cout << "gueltige roemische Zahl " << endl;
   const short int zz = zahlenwert(werte, given.size());
   cout << given << " = " << zz;
 }
 else
 {
    cout << "ungueltige roemische Zahl: " << given;
 }

 cout << "\n\n";
 delete [] werte;          // Freigabe des Speichers
//  system("pause");
 return 0;
}
