//	bung 4 - Aufgabe 14  (dyanmische Arrays und Funktionen)
//	g++ -Wall -Weffc++ -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls -Wunreachable-code -Winline -pedantic bsp_14.cpp
//	icc -strict_ansi -w2 -Wall -Wcheck u4A.cpp
//      valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_14 --show-reachable=yes ./a.out

#include <iostream>
#include <cmath>			// sqrt, sin, M_PI
using namespace std;

// Funktionsdefinitionen (=Funktionsdeklarationen   hier)

//     -----------  inneres Produkt  -------

double innerProd( const double a[], const double b[], const int n )
{
  double sum = 0;
  for (int i=0; i<n; ++i)
  {
    sum += a[i]*b[i];
  }
  
  return sum;
}

//     -----------  Euklidische Norm  -------

double norm( const double a[], const int n )
{
  return sqrt( innerProd(a,a,n) );
}


//     -----------  Initialisiere u  -------

void init_u( double a[], const int& n  )
{
  for (int i=0; i<n; ++i)
  {
    a[i] = 1.0/(i+1.0)/(i+1.0);
  }
  return;
}

//     -----------  Berechnung w_i -------

double fkt_wi( const int& i, const int& n )
{
  return sin(4*(i-1)*M_PI/(n-1.0));
}

//     -----------  Hauptprogramm  -----------
int main()
{
 double *u, *w, *z;		// Pointer fuer dynamische Arrays
    int n;			// Laenge von u und w
 double uw_prod,                // inneres Produkt
        alpha, beta;		// skalare Groesse

//			Datenberechnung und Speicherallokierung
 cout << " Eingabe n = "; cin >> n;

//			Speicher fuer u, w, z
 u = new double [n];
 w = new double [n];
 z = new double [2*n];

//			Berechnung u,w
 init_u( u, n );            //  u
;
 for (int i=0; i<n; ++i )   //   w
   {
     w[i] = fkt_wi( i, n );
   }

//		Berechnung der alpha und beta
 uw_prod = innerProd( u, w, n );
 
 alpha   = uw_prod/norm(u,n);
 beta    = uw_prod/norm(w,n);

//		Berechnung von z
 for ( int i=0; i<n; ++i )
   {
     z[2*i]   =         u[i] + beta * *(w+i);
     z[2*i+1] = alpha * u[i] +        *(w+i);
   }

//		Datenausgabe
 cout << endl << "  Datenausgabe z" << endl << endl;
/* if ( n<=20 )
   {
     for ( i=0; i<2*n; ++i)
       {
         cout << i << " : " << z[i] << endl;
       }
   }
 else*/
   {
     cout << 0     << " : " << z[0]     << endl;
     cout << 1     << " : " << z[1]     << endl;
     cout << 2*n-2 << " : " << z[2*n-2] << endl;
     cout << 2*n-1 << " : " << z[2*n-1] << endl;
   }
 cout << endl;
 cout << " alpha = " << alpha << "    beta = " << beta << endl << endl;

 cout << " || u || = " << norm(u,n) << "    || w || = " <<norm(w,n)
      << "    < u,w > = " << uw_prod << endl;

//		Speicherfreigabe
 delete [] z;
 delete [] w;
 delete [] u;

}
