//      SS07, Aufg. 18: Integrieren

//	g++ -Wall -pedantic bsp_18.cpp
#include <iostream>
#include <cmath>
using namespace std;

//    Riemann-Integration
double riemann( double (* const func)(double), const double &a, const double &b, 
		const int n)
{
  double s = 0.0,       //  Summe
         h = (b-a)/n;   //  Intervalllaenge
  
  for (int j=1; j<=n; ++j)
  {
    s += func(a+j*h)*h;
  }
 
  return s;
}

//    Hauptprogramm: 
int main(const int argc, const char* argv[])
{
 const int N=10;
 double r1,r2,r3;
 
 r1 = riemann(sqrt, 1, 4, N);            //    14/3 : 2/3*sqrt(x^3)
 
 r2 = riemann(cos, 0, M_PI/2, N);        //    1    :  sin(x)
 
 r3 = riemann(log, 1, M_E, N);           //    1    :  x*ln(x)-x
 
 cout << endl;
 cout << "integral sqrt in [1,4]    :  " << r1 << endl;
 cout << "integral cos  in [0,pi/2] :  " << r2 << endl;
 cout << "integral log  in [0,e]    :  " << r3 << endl;
 

 return 0;
}
