//  g++ -O2 -Wall -pedantic bsp_28.cpp bsp_28vec_fkt.cpp

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <cassert>
using namespace std;

#include "bsp_28vec_fkt.hpp"

//   Implementation of the methods from class polynom

//
polynom::polynom()
 : coeff(0)               // member initialization
{
}


//
// polynom::polynom(const polynom& rhs)
//  : coeff(rhs.coeff)
// {
// //   coeff = new double [degree()+1];
// //   for (int i=0; i<=degree(); ++i)
// //   {
// //      coeff[i] = rhs.coeff[i];
// //   }
// //
// //   return;
// }


//
polynom::polynom(const string& file_name)
 : coeff(0)            // guarantee defined values
{
 ifstream fin(file_name.c_str());

 if( fin.is_open() )
 {
    int ngrad;
    fin >> ngrad;
//     cout << ngrad << endl;
    coeff.resize(ngrad+1);           // allocate ngrad+1 !!
    for (int i=0; i<=ngrad; ++i)
    {
      fin >> coeff[i];
//     cout << coeff[i] << endl;
    }
 }
 else
 {
    cout << "\nFile " << file_name << "have not been found.\n" ;
    assert( fin.is_open() );         // exeption handling for the poor programmer
 }
 return;
}


//
polynom::~polynom()
{
}


//
polynom& polynom::operator=(const polynom& rhs)
{
  if ( &rhs != this)
  {
    coeff = rhs.coeff;
  }

  return *this;
}


ostream & operator<<(ostream  & s, const polynom & orig)
{
  s << " Polynom of degree " << orig.degree() << "has coefficient in decending order" << endl;
  cout.precision(3);
  for (int i=0; i<=orig.degree(); ++i)
    {
       s << orig[i] << "  ";
    }
  s << endl;

  return s;
}

//
double polynom::horner(const double x) const
{
  double sum = coeff[degree()];

  for (int k=degree()-1; k>=0; --k)
  {
    sum = x*sum + coeff[k];        // x*()+a_k
//     sum = x*sum + (*this)[k];        // x*()+a_k
  }

  return sum;
}


//
double polynom::polynom_mult(const double x) const
{
  double sum = coeff[0],
         xp  = 1.0;    // x^0

  for (int k=1; k<=degree(); ++k)
  {
    xp  *= x;             // x^k
    sum += coeff[k]*xp;   // + a_k*x^k
  }

  return sum;
}


//
double polynom::polynom_pow(const double x) const
{
  double sum = 0.0;
  for (int k=0; k<=degree(); ++k)
  {
    sum += coeff[k]*pow(x,k);   // + a_k*x^k
  }

  return sum;
}

//  #########  Playing around with loop unrolling pays off for horner2 and polynom_mult2  #####
//
// double polynom::horner2(const double x) const
// {
//   const double xx = x*x;
//   double sum = coeff[degree()];
//
//   int n = degree()-1;
//   if ( n%2 == 0)
//   {
//     sum = sum*x+coeff[n];
//     --n;
//   }
//
//   for (int k=n; k>=0; k -= 2)
//   {
// //     sum = (x*sum + coeff[k])*x+coeff[k-1];
//     const double t = coeff[k]*x+coeff[k-1];
//     sum = xx*sum + t;
//   }
//
//   return sum;
// }


// double polynom::polynom_mult2(const double x) const
// {
//   double sum1 = coeff[0],
//          xp1  = 1.0,
//          xp2  = x,
//          sum2 = x*coeff[1];
//   const double xx = x*x;
//
//   int n = degree();
//   if ( degree()%2 == 0)  --n;
//
//   for (int k=2; k<=n; k+=2)
//   {
//     xp1  *= xx;
//     sum1 += coeff[k]*xp1;
//     xp2  *= xx;
//     sum2 += coeff[k+1]*xp2;
//   }
//
//   double sum = sum1+sum2;
//   if ( degree()%2 == 0)  sum += coeff[degree()]*xp1*xx;
//
//   return sum;
// }
