// kdoc -p -d spar.docu spar.hpp

#ifndef FILE_BSP_29_FKT
#define FILE_BSP_29_FKT

#include <iostream>
using namespace std;

//                   Piggy bank
class SparSchwein
{
 //     Methods
 public:
 //         Standard and parameter constructor
  SparSchwein(const int max_coins=50, const int num_1c=0, const int num_10c=0,
              const int num_50c=0, const int num_1e=0);

 //        Initialize empty piggy bank
 void init();
 //        Put n 1-cent coins into bank, returns number of remaining coins if bank is full
 int add1Cents(const unsigned int n);
 //        Put n 10-cent coins into bank, returns number of remaining coins if bank is full
 int add10Cents(const unsigned int n);
 //        Put n 50-cent coins into bank, returns number of remaining coins if bank is full
 int add50Cents(const unsigned int n);
 //        Put n 1-Euro coins into bank, returns number of remaining coins if bank is full
 int add1Euro(const unsigned int n);
 //        Check whether bank is empty
 bool isEmpty();
 //        Check whether bank is full
 bool isFull();
 //        Check whether bank is broken
 bool isBroken();
 //        Break into piggy bank and empty it. Return amount of money in bank.
 float breakInto();
 //        Print the number of coins in piggy bank
 friend ostream& operator<<(ostream& s, const SparSchwein& orig);
 //     Members
 private:
  static const unsigned int _val_1c  = 1,
                            _val_10c = 10,
                            _val_50c = 50,
                            _val_1e  = 100;  // value of the coins (one for  a l l   instances)
        unsigned int _cent_1, _cent_10, _cent_50, _euro_1;   // Counter for the different coins
  const unsigned int _max_coins;            // max. number of coins in piggy bank
        bool         _broken;               // broken into piggy bank
};


#endif

//---------------------------------------------------------------------
