#include <iostream>
#include <fstream>
#include <string>
#include <cassert>
using namespace std;

#include "bsp_30_fkt.hpp"

Handy::Handy()
 : device_(string()), name_(string()), surname_(string()), number_(string()), price_(0.0)
{}

Handy::Handy(const string& device,  const string& name,
             const string& surname, const string& number, const float& price)
 : device_(device), name_(name), surname_(surname), number_(number), price_(price)
{}

bool Handy::operator< (const Handy& rhs) const
{
  return ( GetName() < rhs.GetName() ||
          (GetName() == rhs.GetName() && GetSurname() < rhs.GetSurname()) );
}


ostream& operator<<(ostream& s, const Handy& orig)
{
  s << " Device: " << orig.GetDevice() << endl;
  s << " Nutzer: " << orig.GetSurname() << "  " << orig.GetName() << endl;
  s << " Nummer: " << orig.GetNumber() << endl;
  s << " Preis : " << orig.GetPreis() << endl;
return s;
}

// istream& operator>>(istream& s, Handy& orig);
// {
//   s. >> orig.SetDevice() << endl;
//   s << " Nutzer: " << orig.GetSurname() << "  " << orig.GetName() << endl;
//   s << " Nummer: " << orig.GetNumber() << endl;
//   return s;
// }

// -----------------------------------------------------------------------

TelefonBook::TelefonBook(const string& filename)
 : entries_()
{
 ifstream infile(filename.c_str());
 if ( !infile.is_open() )
 {
   cout << "File  " << filename << "  wurde nicht gefunden" << endl;
   assert(infile.is_open());
 }

 while (!infile.eof() && entries_.size()<10)
 {
   string a,b,c,d;
   getline(infile,a);
   getline(infile,b);
   getline(infile,c);
   getline(infile,d);
   float pp;
   infile >> pp;
   cout << pp << endl;
   string tmp;
   getline(infile,tmp);  // read remaining line with the price
   getline(infile,tmp);  // read intermediate line

   entries_.push_back(Handy(a,b,c,d,pp));
//    if (entries_.size()==5) break;
 }

 return;
}


void TelefonBook::Sort()
{
  sort(entries_.begin(), entries_.end() );
}


ostream& operator<<(ostream& s, const TelefonBook& orig)
{
  s << endl << "#################" << endl;
  for (unsigned int i=0; i<orig.size(); ++i )
  {
    s << orig[i] << endl;
  }
  s << endl;
  return s;
}
