// kdoc -p -d spar.docu spar.hpp

#ifndef FILE_BSP_30_FKT
#define FILE_BSP_30_FKT

#include <iostream>
#include <fstream>
#include <string>
#include <vector>
using namespace std;

//                   Piggy bank
class Handy
{
 //     Methods
 public:
 // the default copy constructor, destructor and assign operator
 //             work properly without explicit coding.
 //
  Handy();
 //
  Handy(const string& device, const string& name, const string& surname,
        const string& number, const float &price);
 //
  void SetDevice(const string& device)
       { device_ = device; };
 //
  const string& GetDevice() const
       { return device_; };
 //
  void SetName(const string& name)
       { name_ = name; };
 //
  const string& GetName() const
       { return name_; };
 //
  void SetSurname(const string& surname)
       { surname_ = surname; };
 //
  const string& GetSurname() const
       { return surname_; };
  //
  void SetNumber(const string& number)
       { number_ = number; };
 //
  const string& GetNumber() const
       { return number_; };
 //
  const double GetPreis() const
       { return price_; };
  //
  bool operator< (const Handy& rhs) const;

 //
 friend ostream& operator<<(ostream& s, const Handy& orig);
 //
//  friend istream& operator>>(istream& s, Handy& orig);

 //     Members
 private:
  string device_ ,
           name_ ,
	  surname_ ,
	   number_ ;
  float   price_ ;
};


class TelefonBook
{
 public:
  // the default standard constructor, copy constructor, destructor and assign operator
  //             work properly without explicit coding.
  //
  TelefonBook(const string& filename);
 //
  void Sort();
  //
  unsigned int size() const
       { return entries_.size(); };
  //
  const Handy& operator[](const unsigned int& k) const
       { return entries_[k]; };
  //
//   Handy& operator[](const unsigned int& k)    // not needed
//        { return entries_[k]; };
  //
 friend ostream& operator<<(ostream& s, const TelefonBook& orig);

 private:
  vector<Handy> entries_;

};

#endif

//---------------------------------------------------------------------
