//	SS07, 3. Uebung, Aufgabe 7   (Sudoku)
//	g++ -Wall -Weffc++ -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls -Wunreachable-code -Winline -pedantic bsp_7.cpp

#include <iostream>
using namespace std;

int main()
{
 const int Nsmall = 3,       //  Dimension des kleinen Kaestchens im Sudoku
           N = Nsmall*Nsmall;//  Dimension des Gesamtsudokus

// ---------------------------------------------------------------------
//  Initialisierung des Sudokus mit dem Beispiel des bungszettels
 const int aa[N][N] = 
   { {8 , 9 , 4 , 1 , 2 , 3 , 7 , 5 , 6},
     {7 , 2 , 3 , 5 , 9 , 6 , 1 , 8 , 4},
//      {6 , 5 , 1 , 4 , 8 , 7 , 3 , 9 , 2},	// korrekte Zeile
     {6 , 5 , 1 , 4 , 8 , 6 , 3 , 9 , 2},	// inkorrekte Zeile
     {3 , 4 , 9 , 2 , 7 , 8 , 5 , 6 , 1},
     {5 , 7 , 6 , 9 , 3 , 1 , 4 , 2 , 8},
     {2 , 1 , 8 , 6 , 4 , 5 , 9 , 7 , 3},
     {1 , 6 , 7 , 3 , 5 , 2 , 8 , 4 , 9},
     {4 , 3 , 5 , 8 , 6 , 9 , 2 , 1 , 7},
     {9 , 8 , 2 , 7 , 1 , 4 , 6 , 3 , 5}  };

// ---------------------------------------------------------------------
//  Initialisierung eines weitern Sudokus
 const int a_nn[N][N] = 
   { {4 , 7 , 5 , 3 , 8 , 1 , 9 , 2 , 6},
     {2 , 1 , 8 , 6 , 9 , 7 , 4 , 3 , 5},
     {3 , 6 , 9 , 2 , 5 , 4 , 1 , 7 , 8},
     {8 , 2 , 3 , 5 , 1 , 6 , 7 , 4 , 9},
     {1 , 5 , 4 , 9 , 7 , 2 , 8 , 6 , 3},
     {7 , 9 , 6 , 4 , 3 , 8 , 5 , 1 , 2},
     {9 , 3 , 1 , 7 , 6 , 5 , 2 , 8 , 4},
     {6 , 4 , 7 , 8 , 2 , 9 , 3 , 5 , 1},
     {5 , 8 , 2 , 1 , 4 , 3 , 6 , 9 , 7}  };


// ---------------------------------------------------------------------        
//  Ueberpruefen des Sudokus
//  Ueberpruefen, ob alle Eintraege aus [1,N] sind
 bool  bint = true;
 for (int i=0; i<N; ++i)
 {
   for (int j=0; j<N; ++j)
   {
     bint = bint &&  (1<=aa[i][j] && aa[i][j]<=N );
   }
 }
 cout << endl;
 if ( !bint )  cout << "Unzulaessige Eintraege in der Matrix!"<< endl;

// ---------------------------------------------------------------------
// Ueberpruefen der Zeilen und Spalten
 bool bzeile  = true,
      bspalte = true;
 
 for (int i=0; i<N; ++i)
 {
   bool bz[N] = {};       // Fuer jedes "i" wird array mit "false" initialisiert   
   //  bz[jj-1] ist genau dann wahr, wenn jj mind. einmal in der Zeile vorkommt
   //  Bei mehrfachem Vorkommen von jj in der Zeile muss mind. ein kk in der
   //  Zeile nicht vorkommen, d.h. bz[kk-1] bleibt "false"
   bool bs[N] = {};       // Fuer jedes "i" wird array mit "false" initialisiert
   for (int j=0; j<N; ++j)
   {
     bz[ aa[i][j] - 1 ] = true;
     bs[ aa[j][i] - 1 ] = true;
   }
   
   // Ist Zeile i zulaessig?
   bool bzi=true;
   for (int jj=0; jj<N; ++jj)
   {
     bzi = bzi && bz[jj];
   }
   if (!bzi)  cout << "Zeile " << i+1 << " unzulaessig." << endl;
   bzeile = bzeile && bzi;
   
   // Ist Spalte i zulaessig?
   bool bsi=true;
   for (int jj=0; jj<N; ++jj)
   {
     bsi = bsi && bs[jj];
   }
   if (!bsi)  cout << "Zeile " << i+1 << " unzulaessig." << endl;
   bspalte = bspalte && bsi;
 }

// ---------------------------------------------------------------------
// Ueberpruefung der Unterbloecke
 bool bblock = true;
 for (int i=0; i<N; i+=Nsmall)
 {
   for (int j=0; j<N; j+=Nsmall)
   {
//   aa[i,j] ist die linke obere Ecke des Unterblocks
//   k, l sind die Zeilen/Spalten des Unterblocks
 
     bool bb[N] = {};   // Fuer jeden Unterblock" wird array mit "false" initialisiert
//  bb[jj-1] ist genau dann wahr, wenn jj mind. im Block vorkommt
//  Bei mehrfachem Vorkommen von jj im Blocke muss mind. ein kk im Block
//  nicht vorkommen, d.h. bz[kk-1] bleibt "false" 
     for (int k=0; k<Nsmall; ++k)
     {
       for (int l=0; l<Nsmall; ++l)
       {
         bb[ aa[i+k][j+l] -1 ] = true;
       }
     }
     
      // Ist der Block ab (i,j) zulaessig?
     bool bbi=true;
     for (int jj=0; jj<N; ++jj)
     {
       bbi = bbi && bb[jj];
     }
     if (!bbi)  cout << "Block ab (" << i+1 << "," << j+1 << 
                         ") ist unzulaessig." << endl;
     bblock = bblock && bbi;
   }
 }

// ---------------------------------------------------------------------
 cout << "Die Sudoku-Matrix ist ";
 if ( bint && bzeile && bspalte && bblock)
 {
   cout << "zulaessig!";
 }
 else
 {
   cout << "nicht zulaessig !!!!!!!!!!";
 }
 cout << endl << endl;


 system("pause");
 return 0;
}
