//	bung 4 - Aufgabe 9  (dynamische Arrays)
//			Variante: Ortsvektor als struct
//	g++ -Wall -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls  -Winline -pedantic bsp_9.cpp
//	icc -strict_ansi -w2 -Wall -Wcheck bsp_9.cpp
// valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_9 --show-reachable=yes ./a.out

#include <iostream>
//			/usr/include/g++/cmath
//			/usr/include/math.h
#include <cmath>			// sqrt, acos, M_PI
#include <string>
#include <fstream>
using namespace std;

struct Point3D
   {
     double x,y,z;		// Koordinaten Richtungsvektor
   };

int main()
{
 const double Rad2Grad = 180.0/M_PI;	// Umrechnungsfaktor Radiant in Grad

 Point3D  *a;			// Dynam. Feld von Richtungsvektoren
  double  *anorm;		// Dynamisches Feld der zugehoerigen Normen
     int  n;			// Anzahl der Richtungsvektoren
  double  winkel;		// Winkel,
     int  iw,jw;		// Index der Ortvektoren mit max. Winkel zueinander
			// Hilfsgroessen
  double tw,tp,x,y,z,norm_i;
     int i,j;


//			Dateneinlesen und Speicherallokierung
 const    string   filename("input.9_2.txt"); 
          ifstream infile( filename.c_str() );
	  
//  cout << endl << " Eingabe n = "; 
 infile >> n;

//			Speicher fuer a und Norm_a
 a     = new Point3D [n];
 anorm = new double [n];

//			Dateneinlesen und Normberechnung verbinden.
 for ( i=0; i<n; ++i)
   {
//     cout << " x  y  z  =  ";
     infile >> a[i].x >> a[i].y >> a[i].z;
   }

//			max. Winkel im Bogenmass (Rad) bestimmen
 winkel = 0.0;
 for ( i=0; i<n; ++i)
   {
     x      = a[i].x;		// Spart Feldzugriffe in j-Schleife
     y      = a[i].y;
     z      = a[i].z;
     anorm[i] = norm_i = sqrt(x*x+y*y+z*z);	// Normberechnung

     for ( j=0; j<i; ++j)	// Symmetrie ausnutzen!
       {			// Alle Normen mit j<i sind schon berechnet
         tp = x*a[j].x + y*a[j].y + z*a[j].z;		// inneres Produkt
	 tw = acos( tp / ( norm_i * anorm[j] )  );
	 if ( tw > winkel)
	   {
	     winkel = tw;
	     iw     = i;
	     jw     = j;
	   }
       }
   }
 winkel = winkel * Rad2Grad;		// Umrechnung auf Grad

// 		Ergennisausgabe
 cout << endl << endl;
 cout << "  Max. Winkel ist  " << winkel << "  fuer die Vektoren" << endl;
 cout << "   a[" << iw << "] = (" << a[iw].x << " , " << a[iw].y << " , " << a[iw].z << ")" << endl;
 cout << "   a[" << jw << "] = (" << a[jw].x << " , " << a[jw].y << " , " << a[jw].z << ")" << endl;
 cout << endl << endl;

//		Speicherfreigabe
 delete [] anorm;
 delete [] a;

}































