//	bung 4 - Aufgabe 9  (dynamische Arrays)
//			Variante: Ortsvektor als 1D-Array
//	g++ -Wall -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls  -Winline -pedantic bsp_9_2d.cpp
//	icc -strict_ansi -w2 -Wall -Wcheck bsp_9_2d.cpp
//	valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_9 --show-reachable=yes ./a.out

#include <iostream>
#include <cmath>			// sqrt, acos, M_PI
#include <string>
#include <fstream>
using namespace std;

typedef double Ort[3];

int main()
{
 const double Rad2Grad = 180.0/M_PI;	// Umrechnungsfaktor Radiant in Grad

 Ort  *a;			// Dynam. Feld von Richtungsvektoren
  double  *anorm;		// Dynamisches Feld der zugehoerigen Normen
     int  n;			// Anzahl der Richtungsvektoren
  double  winkel;		// Winkel,
     int  iw,jw;		// Index der Ortvektoren mit max. Winkel zueinander
			// Hilfsgroessen
  double tw,tp,x,y,z,norm_i;
     int i,j;


//			Dateneinlesen und Speicherallokierung
 const    string   filename("input.9_2.txt"); 
          ifstream infile( filename.c_str() );

//  cout << endl << " Eingabe n = "; 
 infile >> n;

//			Speicher fuer a und Norm_a
 a     = new Ort [n];
 anorm = new double [n];

//			Dateneinlesen und Normberechnung verbinden.
  for ( i=0; i<n; ++i)
    {
//      cout << " x  y  z  =  ";
      infile >> a[i][0] >> a[i][1] >> a[i][2];
    }

//			max. Winkel im Bogenmass (Rad) bestimmen
 winkel = 0.0;
 for ( i=0; i<n; ++i)
   {
     x      = a[i][0];		// Spart Feldzugriffe in j-Schleife
     y      = a[i][1];
     z      = a[i][2];
     anorm[i] = norm_i = sqrt(x*x+y*y+z*z);	// Normberechnung

     for ( j=0; j<i; ++j)	// Symmetrie ausnutzen!
       {			// Alle Normen mit j<i sind schon berechnet
         tp = x*a[j][0] + y*a[j][1] + z*a[j][2];		// inneres Produkt
	 tw = acos( tp / ( norm_i * anorm[j] )  );
	 if ( tw > winkel)
	   {
	     winkel = tw;
	     iw     = i;
	     jw     = j;
	   }
       }
   }
 winkel = winkel * Rad2Grad;		// Umrechnung auf Grad

// 		Ergennisausgabe
 cout << endl << endl;
 cout << "  Max. Winkel ist  " << winkel << "  fuer die Vektoren" << endl;
 cout << "   a[" << iw << "] = (" << a[iw][0] << " , " << a[iw][1] << " , " << a[iw][2] << ")" << endl;
 cout << "   a[" << jw << "] = (" << a[jw][0] << " , " << a[jw][1] << " , " << a[jw][2] << ")" << endl;
 cout << endl << endl;

//		Speicherfreigabe
 delete [] anorm;
 delete [] a;

}































