//	SS07, x. Uebung, Aufgabe x   (Horner)
//	g++ bsp_1.cpp

#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
using namespace std;

void save_koeff(const string& name, const int n, const double a[])
{
 ofstream fout(name.c_str());

 fout << n << endl;
 for (int i=0; i<=n; ++i)
 {
   fout << a[i] << "  ";
 }
 cout << endl;
 return;
}

//--------------------------
double polynom_pow(const double x, const int n, const double a[])
{
  double sum = 0.0;
  for (int k=0; k<=n; ++k)
  {
    sum += a[k]*pow(x,k);   // + a_k*x^k
  }

  return sum;
}

//--------------------------
double polynom(const double x, const int n, const double a[])
{
  double sum = a[0],
         xp  = 1.0;    // x^0

  for (int k=1; k<=n; ++k)
  {
    xp  = xp*x;            // x^k
    sum += a[k]*xp;   // + a_k*x^k
  }

  return sum;
}

//--------------------------
double horner(const double x, const int n, const double a[])
{
  double sum = a[n];

  for (int k=n-1; k>=0; --k)
  {
    sum = x*sum + a[k];        // x*()+a_k
  }

  return sum;
}

//--------------------------

int main()
{
 const double aa[] = {1.0, 4.0, 0.0, -2.0, 3.0};
 const int    l_a  = sizeof(aa)/sizeof(aa[0])-1;

 cout << "Polynomgrad " << l_a-1 << endl;

 double  x = 2.0;
 double px = polynom(x, l_a, aa),
        ppx = polynom_pow(x, l_a, aa),
        hx = horner(x, l_a, aa);
 cout << " px = " << px << "   ppx = " << ppx << "   hx = " << hx <<  endl;


 const int N = 90, NITER = 1000;
//   const int N = 100000, NITER = 1000;
double *a = new double [N+1];

 for (int i=0; i<=N; ++i)
 {
   a[i] = (2*rand()-1.0)/RAND_MAX;
//    a[i] = (2*rand()-1.0)/RAND_MAX/(i*i*i+1.0);
//    cout << " " << a[i];
 }

 x = -0.945;
 double t,t1,t2,t3;

 t = clock();
 for (int j=0;j<NITER;++j)  px  = polynom(x, N, a);
 t1 = clock()-t;
 t1 /= CLOCKS_PER_SEC;


 t = clock();
 for (int j=0;j<NITER;++j)  ppx = polynom_pow(x, N, a);
 t2 = clock()-t;
 t2 /= CLOCKS_PER_SEC;

 t = clock();
 for (int j=0;j<NITER;++j)  hx  = horner(x, N, a);
 t3 = clock()-t;
 t3 /= CLOCKS_PER_SEC;

 cout << " px = " << px << "   ppx = " << ppx << "   hx = " << hx <<  endl;
 cout << " t1 = " << t1 << "    t2 = " <<  t2 << "   t3 = " << t3 <<  endl;

 save_koeff("data_23_b.txt", N, a);

 delete [] a;

//  system("pause");
 return 0;
}
